from tkinter import *
from PIL import Image, ImageTk #pip install pil

import cv2
import sys
import numpy as np

def calculateFocal():
    global isFocal
    global isDistancia
    isDistancia = False
    isFocal = True

def calculateDistance():
    global isDistancia
    global isFocal
    isFocal = False
    isDistancia = True

def onClossing():
    root.quit()         #finaliza este programa
    cap.release()
    print("Ip cam disconected")
    root.destroy()      #Cierra la ventana creada

def hsvValue(int):
    hMin.set(slider1.get())
    hMax.set(slider2.get())
    sMin.set(slider3.get())
    sMax.set(slider4.get())
    vMin.set(slider5.get())
    vMax.set(slider6.get())
     
    
def callback():
        global focal
        
        ret, frame = cap.read()

        if ret:
            
            w = float(entryA.get()) # Alto del objeto en metros
            d = float(entryDis.get())
            u = 0
            
            
            hsv = cv2.cvtColor(frame, cv2.COLOR_BGR2HSV) #Convertirlo a espacio de color HSV
            #Se crea un array con las posiciones minimas y maximas capturadas de los sliders
            lower=np.array([hMin.get(),sMin.get(),vMin.get()])
            upper=np.array([hMax.get(),sMax.get(),vMax.get()])
 
            #Deteccion de colores 
            mask = cv2.inRange(hsv, lower, upper)

            closing = cv2.morphologyEx(mask, cv2.MORPH_CLOSE,kernel)
            
            contours,_ = cv2.findContours(closing.copy(), cv2.RETR_EXTERNAL, cv2.CHAIN_APPROX_SIMPLE)
            
            for cnt in contours:
                momentos = cv2.moments(cnt)
                area = momentos['m00']
                if area > minArea:
                    cx = int(momentos['m10']/momentos['m00']) # u
                    cy = int(momentos['m01']/momentos['m00']) # v
                    
                    (x, y, u, v) = cv2.boundingRect(cnt)
                    cv2.rectangle(frame,(x,y),(x+u,y+v),(255,0,0),3)
                    
                    if isFocal:
                        focal = (u*d)/w # distancia focal
                        distanceFocal.set("Distancia Focal : " +str(round(focal,2)))
                        
                    if isDistancia:
                        distancia = (focal*w)/u
                        
                        #x = cx*distancia/focal
                        #y = cy*distancia/focal

##                        d = np.sqrt((x1-x)**2+(y1-y)**2)

                        print(f" Eje x : {x}")
                        print(f" Eje y : {y}")
                        
                        distanceObject.set("Distancia al objeto : "+str(round(distancia,2)))
                        
                
            
            img = cv2.cvtColor(frame, cv2.COLOR_BGR2RGB)
            img = Image.fromarray(img)
            img.thumbnail((400,400)) #Redimensionar imagen
            tkimage = ImageTk.PhotoImage(img)
            label.configure(image = tkimage )
            label.image = tkimage

            mask = Image.fromarray(mask)
            mask.thumbnail((400,400))
            tkimage1 = ImageTk.PhotoImage(mask)
            label1.configure(image = tkimage1 )
            label1.image = tkimage1
        
            root.after(100,callback)
            
        else:
            onClossing()
            
focal = 0
isFocal = False
isDistancia = False

kernel = np.ones((5,5),np.uint8) # Nucleo

minArea = 1500  # Area minima para considerar que es un objeto            
        
cap = cv2.VideoCapture(0)

if cap.isOpened():
    print("Ip Cam initializatized")
else:
    sys.exit("Ip Cam disconnected")
    
############################## HMI design #################
root = Tk()
root.protocol("WM_DELETE_WINDOW",onClossing)
root.title("Vision Artificial") # titulo de la ventana

label=Label(root) #image = imagen camara opencv / relief = decoracion de borde
label.grid(row=1,padx=20,pady=20)

label1=Label(root)
label1.grid(row= 1,column=1,padx=20,pady=20)

hMin = IntVar()
hMax = IntVar()
sMin = IntVar()
sMax = IntVar()
vMin = IntVar()
vMax = IntVar()

slider1 = Scale(root,label = 'Hue Min', from_=0, to=255, orient=HORIZONTAL,command=hsvValue,length=400)   #Creamos un dial para recoger datos numericos
slider1.grid(row = 2)
slider2 = Scale(root,label = 'Hue Max', from_=0, to=255, orient=HORIZONTAL,command=hsvValue,length=400)   #Creamos un dial para recoger datos numericos
slider2.grid(row = 2,column=1)
slider3 = Scale(root,label = 'Saturation Min', from_=0, to=255, orient=HORIZONTAL,command=hsvValue,length=400)   #Creamos un dial para recoger datos numericos
slider3.grid(row = 3)
slider4 = Scale(root,label = 'Saturation Max', from_=0, to=255, orient=HORIZONTAL,command=hsvValue,length=400)   #Creamos un dial para recoger datos numericos
slider4.grid(row = 3,column=1)
slider5 = Scale(root,label = 'Value Min', from_=0, to=255, orient=HORIZONTAL,command=hsvValue,length=400)   #Creamos un dial para recoger datos numericos
slider5.grid(row = 4)
slider6 = Scale(root,label = 'Value Max', from_=0, to=255, orient=HORIZONTAL,command=hsvValue,length=400)   #Creamos un dial para recoger datos numericos
slider6.grid(row = 4,column=1)

slider2.set(255)
slider4.set(255)
slider6.set(255)

distanceFocal = StringVar(root,"Distancia Focal : 0")
labelF = Label(root, textvariable = distanceFocal)
labelF.grid(row = 5, column = 0,padx = 20,pady = 20)

distanceObject = StringVar(root,"Distancia al objeto : 0")
labelD = Label(root, textvariable = distanceObject)
labelD.grid(row = 5, column =1,padx = 20, pady = 20)

labelA = Label(root, text = "Ingrese ancho (m) :")
labelA.grid( row = 6, column = 0,padx = 20, pady = 20)

entryA = Entry(root)
entryA.grid(row = 7, column = 0)
entryA.insert(0,"0.10")

labelDis = Label(root, text = "Ingrese distancia: ")
labelDis.grid(row = 6,column =1, padx = 20, pady = 20)

entryDis = Entry(root)
entryDis.grid( row = 7, column = 1)
entryDis.insert(0,"0.25")

buttonFocal = Button(root, text = "Distancia Focal", command = calculateFocal)
buttonFocal.grid(row = 8, column =0, padx = 20, pady = 20)

buttonDistance = Button(root, text ="Distancia", command = calculateDistance)
buttonDistance.grid(row = 8, column = 1, padx = 20, pady = 20)


root.after(100,callback) #Es un método definido para todos los widgets tkinter.
root.mainloop()
